--ver: 3.2b
---AddFriend is reserved by WoW, so to prevent conflicts using AFriend
--Call console for commands, event for click events, Hook for any needed hooks into the dropdowns.
AFriend = LibStub("AceAddon-3.0"):NewAddon("AFriend", "AceEvent-3.0", "AceHook-3.0");
local Afriends = LibStub("LibFriends-1.0");
local Aguilds = LibStub("LibGuild-1.0");
local AFriend = AFriend;

local AButtons = {}
AButtons = {"Add_Friend", "Remove_Friend", "Add_Guild", "Remove_Guild"}

local AButtonTxt = {}
AButtonTxt = {"Add Friend", "Remove Friend", "Guild Invite", "Guild Remove"}

local ATargets = {}
ATargets = {"PLAYER", "FRIEND", "RAID", "RAID_PLAYER"}


function AFriend:OnInitialize()
	local versionString = GetAddOnMetadata("AddFriend", "Version");
end

function AFriend:OnEnable()
	for i=1,#ATargets do
		self:AddMenuButtons(ATargets[i])
	end
	for i=1,#AButtons do
		UnitPopupButtons[AButtons[i]] = {text = AButtonTxt[i], dist = 0}
	end
	self:SecureHook("UnitPopup_HideButtons");
	self:SecureHook("UnitPopup_OnClick");
end

local function remove_value(t, val)
	for i,v in pairs(t) do
		if v==val then
			table.remove(t, i)
			break
		end
	end
end

function AFriend:OnDisable()
	self:Unhook("UnitPopup_HideButtons");
	self:Unhook("UnitPopup_OnClick");
	for i=1,#ATargets do
		for x=1,#AButtons do
			remove_value(UnitPopupMenus[ATargets[i]], AButtons[x])
		end
	end
end

function AFriend:AddMenuButtons(which)
	wPH = 0; iPH = 0;
	for i,v in pairs(UnitPopupMenus[which]) do
		if v=="WHISPER" then wPH = i; end
		if v=="INVITE" then iPH = i; end
		if v=="Add_Friend" or v=="Remove_Friend" or  v=="Add_Guild" or v=="Remove_Guild" then UnitPopupShown[i] = (name == UnitName("player") and 0) or 1 end
	end
	table.insert(UnitPopupMenus[which], wPH+1, "Add_Friend")
	table.insert(UnitPopupMenus[which], wPH+1, "Remove_Friend")
	table.insert(UnitPopupMenus[which], iPH+3, "Add_Guild")
	table.insert(UnitPopupMenus[which], iPH+3, "Remove_Guild")
end

function AFriend:UnitPopup_HideButtons()
	local dropdownMenu = UIDROPDOWNMENU_INIT_MENU
	local which = dropdownMenu.which
	local name = dropdownMenu.name
	local unit = dropdownMenu.unit
	thisName = name or UnitName(unit);
	
	which = string.gsub(which, "PB4_", "") --Hack to accept Pitbull4 Unit Frame Menus
	
	for index, v in ipairs(UnitPopupMenus[which]) do
		if v=="Add_Friend" or v=="Remove_Friend" or v=="Add_Guild" or v=="Remove_Guild" then
			if which == "PET" or which == "SELF" then 
				UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0;
			elseif which ~= "FRIEND" and which ~= "PLAYER" and which ~= "PARTY" and which ~= "RAID_PLAYER" and which ~= "RAID" then 
				UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0;
			end
			if (which ~= "FRIEND") and (not UnitCanCooperate("player", unit) or UnitGUID(unit) == UnitGUID("player"))  then 
				UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0;
			end
		end
	
		----------------------------------------------------
		-------------Conditionals for All Menus-------------
		---------------------------------------------------
		if (v=="Add_Guild" or v=="Remove_Guild") and (not IsInGuild() or not CanGuildInvite()) then
			UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0;
		end
		if v=="Remove_Guild" and Aguilds:HasMember(thisName) == nil then
			UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0;
		end
		if v=="Add_Guild" and Aguilds:HasMember(thisName) ~= nil then
			UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0;
		end
		if v=="Add_Friend" and Afriends:HasFriend(thisName) then
			UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0;
		end
		if v=="Remove_Friend" and not Afriends:HasFriend(thisName) then
			UnitPopupShown[UIDROPDOWNMENU_MENU_LEVEL][index] = 0;
		end
	end
end

function AFriend:UnitPopup_OnClick(self)
	local dropdownFrame = UIDROPDOWNMENU_INIT_MENU
	local which = dropdownFrame.which
	local name = dropdownFrame.name
	local unit = dropdownFrame.unit
	local button = self.value;
	thisName = name or UnitName(unit);
	if button == "Add_Friend" then
		AddFriend(thisName);
	end
	if button == "Remove_Friend" then
		RemoveFriend(thisName);
	end
	if button == "Add_Guild" then
		GuildInvite(thisName);
	end
	if button == "Remove_Guild" then
		GuildUninvite(thisName);
	end
end